#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["Karen Spell3"]
#text["Karen's 3rd Spell"]

let bossObj;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "IMG/Karen.png";
let Deepsea = GetCurrentScriptDirectory ~ "IMG/Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "IMG/Deepnessseaweed.png";
let SpellFog = GetCurrentScriptDirectory ~ "IMG/SpellFog.png";


#include "./Custshot/AchyShot_Const.cs"

@Initialize {
	
	bossObj = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(bossObj);
	
	ObjPrim_SetTexture(bossObj,imgBoss);
	ObjSprite2D_SetSourceRect(bossObj,0,0,110,145);
	ObjSprite2D_SetDestCenter(bossObj); 
	//I have no animation for this character	
	ObjEnemy_SetDamageRate(bossObj,0,0);
	ObjMove_SetDestAtSpeed(bossObj,192,120,5);
	
	TEnd;
	
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(4000);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(bossObj);
	BossY = ObjMove_GetY(bossObj);
	
	ObjEnemy_SetIntersectionCircleToShot(bossObj,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(bossObj,BossX,BossY,32);
	
	
	
	yield;
	
}

@Finalize {

}

function wait(w) { loop(w) { yield; } }

task mainTask {
	
	RenderBG;
	wait(70);
	loop{
		wait(90);
		giantflare;
		ObjEnemy_SetDamageRate(bossObj,80,50);
		wait(120);
		ObjMove_SetDestAtWeight(bossObj,rand(90,270),rand(60,160),5,5);
		wait(150);
		someshapething;
		wait(130);
		ObjMove_SetDestAtWeight(bossObj,rand(90,270),rand(60,160),5,5);
		wait(150);
		ObjMove_SetDestAtWeight(bossObj,rand(90,270),rand(60,160),5,5);
		wait(240);
	}

}

task RenderBG {
	//Spellfog & scroll
	let BGobj3 = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(BGobj3,24);
	ObjPrim_SetTexture(BGobj3,SpellFog);
	ObjSprite2D_SetDestRect(BGobj3,0,0,GetStgFrameWidth,GetStgFrameHeight);
	ObjRender_SetAlpha(BGobj3,20);
	let count = 1800;
	wait(1);
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0) {
		ObjSprite2D_SetSourceRect(BGobj3,0,count-900,900,count);
		count--;
		if (count == 900) {count = 1800}
		yield;
	}
	Obj_Delete(BGobj3);
	
}

task giantflare{
	if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	let Flare = CreateShotA2(BossX,BossY-45,0,270,0.001,0.1,230,10);
	ObjShot_SetSpellResist(Flare,true);
	wait(30);
	ascent(i in 1..30) {
		ObjRender_SetScaleX(Flare,1+i*0.5);
		ObjRender_SetScaleY(Flare,1+i*0.5);
		wait(2);
	}
	if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	underpattern(Flare);
}

task underpattern(obj){
	let OBJX = ObjMove_GetX(obj);
	let OBJY = ObjMove_GetY(obj);
	let dir = 0;
	let point = 1.5;
	let graphic = 230;
	loop(14) {
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		loop(8){
			dir+=360/8;
			ascent(i in -1..2) {
				CreateShotA2(OBJX,OBJY,1,dir+i*8,0.01,1.3,230,10);
				if (i == 0) {point = 1.9; graphic = 232;}
				if (i == 1) {point = 1.5; graphic = 230;}
				CreateShotA2(OBJX,OBJY,1,dir+22.5+i*6,0.01,point,graphic,10);
			}
		}
		dir+=360/rand(10,20);
		wait(45);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	wait(120);
	ObjShot_FadeDelete(obj);
	
}

task someshapething {
	
	let shift = 0;
	let dir = 0;
	loop(3) {
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		dir+=360/2.7;
		ascent(i in 0..6){
			if (i == 1) {shift = 4;}
			if (i == 3) {shift = 0;}
			ascent(j in 0..9){
				dir+=360/9;
				let orb1 = CreateShotA2(BossX,BossY-45,2,dir+4+shift,0.01,3-i*0.3,45,10);
				let orb2 = CreateShotA2(BossX,BossY-45,2,dir-4-shift,0.01,3-i*0.3,45,10);	
			}
		wait(5);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		}
	wait(150);
	if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
}

task TEnd{
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(bossObj);
	loop(60) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	CloseScript(GetOwnScriptID());
}