#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["Karen Nonspell #1"]
#text["Karen's 1st Nonspell"]

let bossObj;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "IMG/Karen.png";
let Deepsea = GetCurrentScriptDirectory ~ "IMG/Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "IMG/Deepnessseaweed.png";
let variety = 0;
let angle = 0;
let count = 0;
let MiniLgt;
let Light;

#include "./Custshot/AchyShot_Const.cs"

@Initialize {

	bossObj = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(bossObj);
	
	ObjPrim_SetTexture(bossObj,imgBoss);
	ObjSprite2D_SetSourceRect(bossObj,0,0,110,145);
	ObjSprite2D_SetDestCenter(bossObj); 
	/*I have no animation for this character, 
	so I left the image files in here instead of moving it as 
	advised by Helipolis' tutorial.*/	
	ObjMove_SetPosition(bossObj,192,-120);
	ObjEnemy_SetDamageRate(bossObj,0,0);
	ObjMove_SetDestAtSpeed(bossObj,192,120,5);
	
	
	TEnd;
	
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2000);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(bossObj);
	BossY = ObjMove_GetY(bossObj);
	
	ObjEnemy_SetIntersectionCircleToShot(bossObj,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(bossObj,BossX,BossY,32);
	
	
	
	yield;
	
}

@Finalize {

}

function wait(w) { loop(w) { yield; } }

task mainTask {
	
	RenderBG;
	wait(150);
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0){ 
		Fire1;
		Glow;
		wait(160);
		ObjMove_SetDestAtWeight(bossObj,rand(142,242),rand(80,160),10,4);
		wait(50);
		Fire2;
		wait(160);
		ObjMove_SetDestAtWeight(bossObj,rand(142,242),rand(80,160),10,4);
		wait(50);
	}
}

task RenderBG {
	//Background rendering
	let BGobj = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(BGobj,21);
	ObjPrim_SetTexture(BGobj,Deepsea);
	ObjSprite2D_SetSourceRect(BGobj,0,0,828,980);
	ObjSprite2D_SetDestRect(BGobj,0,0,GetStgFrameWidth,GetStgFrameHeight);
	//Overlay background rendering
	let BGobj2 = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(BGobj2,22);
	ObjPrim_SetTexture(BGobj2,Seaweed);
	ObjSprite2D_SetSourceRect(BGobj2,0,0,828,980);
	ObjSprite2D_SetDestRect(BGobj2,0,0,GetStgFrameWidth,GetStgFrameHeight);
}

task Fire1 {
	//bullet pattern.
	ObjEnemy_SetDamageRate(bossObj,80,50);
	let variety = rand(-11.25,11.25);
	loop(2) {
		loop(32) {
			angle+=360/32;
			CreateShotA2(BossX,BossY,3,angle+5.625+variety,-0.01,1,17,10);
		}
		wait(10);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	loop(6) {
		ascent(i in 1..21) {
			angle+=360/16;
			CreateShotA2(BossX,BossY,3,angle+variety+2,0.01,3,19,10);
			CreateShotA2(BossX,BossY,3,angle+variety-2,0.01,3,19,10);

		}
		wait(5);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	loop(2) {
		loop(32) {
			angle+=360/32;
			CreateShotA2(BossX,BossY,3,angle+5.625+variety,-0.01,1,17,10);
		}
		wait(10);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	loop(6) {
		ascent(i in 1..21) {
			angle+=360/16;
			CreateShotA2(BossX,BossY,3,angle+11.25+variety+2,0.01,3,19,10);
			CreateShotA2(BossX,BossY,3,angle+11.25+variety-2,0.01,3,19,10);

		}
		wait(5);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
}

task Fire2 {
	//Same as Fire1, but different colouring
	let variety = rand(-11.25,11.25);
	loop(2) {
		loop(32) {
			angle+=360/32;
			CreateShotA2(BossX,BossY,3,angle+5.625+variety,-0.01,1,19,10);
		}
		wait(10);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	loop(6) {
		ascent(i in 1..21) {
			angle+=360/16;
			CreateShotA2(BossX,BossY,3,angle+variety+2,0.01,3,17,10);
			CreateShotA2(BossX,BossY,3,angle+variety-2,0.01,3,17,10);

		}
		wait(5);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	loop(2) {
		loop(32) {
			angle+=360/32;
			CreateShotA2(BossX,BossY,3,angle+5.625+variety,-0.01,1,19,10);
		}
		wait(10);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
	loop(6) {
		ascent(i in 1..21) {
			angle+=360/16;
			CreateShotA2(BossX,BossY,3,angle+11.25+variety+2,0.01,3,17,10);
			CreateShotA2(BossX,BossY,3,angle+11.25+variety-2,0.01,3,17,10);

		}
		wait(5);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	}
}

 //help from Drake
task Glow {
       //Current task for the "leader" Bullet
       loop(16){
          Glowandtrail;
          wait(26);
		  if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
       }
    }
     
 //help from Drake and Talos
task Glowandtrail{
       //Current task for the disappearing bullet trail following the leading bullet
		let randir = rand(-0.6,0.6);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		let obj = CreateShotB2(BossX,BossY-45,randir,-3,0,0.05,0,2,224,25);
		wait(70);
		while(!Obj_IsDeleted(obj)) { 
			// this means "while the "obj" variables still exist, do something in the next bracket
			// Otherwise,skip every thing in the next bracket
			let LgtX = ObjMove_GetX(obj);
			let LgtY = ObjMove_GetY(obj);
			let MiniLgt = CreateShotA2(LgtX,LgtY,0,ObjMove_GetAngle(obj)+rand(-30,30),0.5,0.5,55,0);
			deletetrail(MiniLgt);
			wait(8);
			if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
       }
}
 //learned task arguments from Talos
task deletetrail(obj2) {

	wait(45);
	ObjShot_FadeDelete(obj2);

}

task TEnd{
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(bossObj);
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	loop(120) {
		DeleteShotAll(TYPE_ALL,TYPE_IMMEDIATE);
		yield;
	}
	CloseScript(GetOwnScriptID());
}