#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["Karen Nonspell #2"]
#text["Karen's 2nd Nonspell"]

let bossObj;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "IMG/Karen.png";
let Deepsea = GetCurrentScriptDirectory ~ "IMG/Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "IMG/Deepnessseaweed.png";
let variety = 0;
let angle = 0;
let count = 0;
let MiniLgt;
let Light;

#include "./Custshot/AchyShot_Const.cs"

@Initialize {

	bossObj = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(bossObj);
	
	ObjPrim_SetTexture(bossObj,imgBoss);
	ObjSprite2D_SetSourceRect(bossObj,0,0,110,145);
	ObjSprite2D_SetDestCenter(bossObj); 
	ObjEnemy_SetDamageRate(bossObj,0,0);
	ObjMove_SetDestAtSpeed(bossObj,192,120,5);
	
	TEnd;
	
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2400);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(bossObj);
	BossY = ObjMove_GetY(bossObj);
	
	ObjEnemy_SetIntersectionCircleToShot(bossObj,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(bossObj,BossX,BossY,32);
	
	
	
	yield;
	
}

@Finalize {

}

function wait(w) { loop(w) { yield; } }

task mainTask {

	wait(200);
	ObjEnemy_SetDamageRate(bossObj,80,50);
	OrbLtg;
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0){ 
		wait(150);
		ObjMove_SetDestAtWeight(bossObj,rand(70,GetStgFrameWidth-70),rand(70,120),5,5);
		wait(50);
		SpreadFire;
	}
}

task SpreadFire{
	let Colorchange = 0;
	ascent(i in 0..3) {
		if (i == 1) {Colorchange+=2;}
		ascent(j in -10..11) {
				CreateShotA2(BossX,BossY,3+i*0.3,GetAngleToPlayer(bossObj)+j*8,-0.02,0.4+i*0.3,17+Colorchange,10);
		}
	}
}

task OrbLtg {
	let abullet = []; //[] = an array
	
	
	ascent(m in 0..4) { //number of bullets, and number to add to the array
		abullet = append(abullet,CreateShotA1(-50,-50,0,0,235,20)); //append adds to the array
		ObjShot_SetSpellResist(abullet[m],true); //sets spell resistance to each array bullet
	}
	wait(10);
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0){ 
		let timer1 = round(rand(20,90));
		let timer2 = round(rand(111,180));
		let timer3 = round(rand(200,270));
		let timer4 = round(rand(290,360));
		ascent(i in 0..360){
			ascent(i2 in 0..length(abullet)){
				let angle = 360/length(abullet)*i2;
				ObjMove_SetPosition(abullet[i2],GetStgFrameWidth/2+GetStgFrameWidth/2*cos(angle+i),20+30*sin(angle+i));
				if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
				if (i == timer1){Glowandtrail(abullet[i2],120);}
				if (i == timer2){Glowandtrail(abullet[i2],70);}
				if (i == timer3){Glowandtrail(abullet[i2],120);}
				if (i == timer4){Glowandtrail(abullet[i2],70);}
			}
			wait(1);
			if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		}
	}
}
     
task Glowandtrail(obj3,dir){
		let obj3X = ObjMove_GetX(obj3);
		let obj3Y = ObjMove_GetY(obj3);
		let obj = CreateShotA1(obj3X,obj3Y,2,dir,224,0);
		ReflectWalls(obj,ObjMove_GetAngle(obj));
		wait(1);
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		while(!Obj_IsDeleted(obj)) { 
			let LgtX = ObjMove_GetX(obj);
			let LgtY = ObjMove_GetY(obj);
			if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
			let MiniLgt = CreateShotA2(LgtX,LgtY,0,ObjMove_GetAngle(obj)+rand(-30,30),0.5,0.5,55,0);
			deletetrail(MiniLgt);
			wait(8);
			if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
       }
}

task deletetrail(obj2) {

	wait(45);
	ObjShot_FadeDelete(obj2);

}

task ReflectWalls(obj,ang) {
	while (ObjMove_GetX(obj)>0&&ObjMove_GetX(obj)<GetStgFrameWidth) {yield;}
	if (ObjMove_GetX(obj)<=0) {
			ObjMove_SetX(obj,0);
			ObjMove_SetAngle(obj,180-ang);
		}
	if (ObjMove_GetX(obj)>=GetStgFrameWidth) {
			ObjMove_SetX(obj,GetStgFrameWidth);
			ObjMove_SetAngle(obj,180-ang);
		}
}

task TEnd{
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(bossObj);
	loop(60) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	CloseScript(GetOwnScriptID());
}