#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["Karen Spell #1"]
#text["Karen's 1st Spellcard"]

let BossObj;
let BossX = 0;
let BossY = 0;
let ImgBoss = GetCurrentScriptDirectory ~ "IMG/Karen.png";
let Deepsea = GetCurrentScriptDirectory ~ "IMG/Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "IMG/Deepnessseaweed.png";
let SpellFog = GetCurrentScriptDirectory ~ "IMG/SpellFog.png";

#include "./Custshot/AchyShot_Const.cs"

@Initialize {

	BossObj = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(BossObj);
	
	ObjPrim_SetTexture(BossObj,ImgBoss);
	ObjSprite2D_SetSourceRect(BossObj,0,0,110,145);
	ObjSprite2D_SetDestCenter(BossObj); 	
	ObjEnemy_SetDamageRate(BossObj,0,0);
	ObjMove_SetDestAtSpeed(BossObj,192,120,5);
	
	EndScript;
	
	MainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(4500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(BossObj);
	BossY = ObjMove_GetY(BossObj);
	
	ObjEnemy_SetIntersectionCircleToShot(BossObj,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(BossObj,BossX,BossY,32);
	
	
	
	yield;
	
}

@Finalize {

}

function wait(w) { loop(w) { yield; } }

task MainTask {
	RenderBG;
	loop{
	wait(180);
	atk1(25);
	wait(180);
	TSquare(GetPlayerObjectID,rand(0,360),150);
	}
}

task RenderBG {
	//Spellfog & scroll
	let BGobj3 = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(BGobj3,24);
	ObjPrim_SetTexture(BGobj3,SpellFog);
	ObjSprite2D_SetDestRect(BGobj3,0,0,GetStgFrameWidth,GetStgFrameHeight);
	ObjRender_SetAlpha(BGobj3,20);
	let count = 1800;
	wait(1);
	while(ObjEnemy_GetInfo(BossObj, INFO_LIFE) > 0) {
		ObjSprite2D_SetSourceRect(BGobj3,0,count-900,900,count);
		count--;
		if (count == 900) {count = 1800}
		yield;
	}
	Obj_Delete(BGobj3);
	
}

task atk1(numbofbullets) {
	ObjEnemy_SetDamageRate(BossObj,80,50);
	let circle = 0;
	let variety = rand(0,90);
	loop(4) {
		loop(numbofbullets) {
			circle+= 360/numbofbullets;
			let reverse = CreateShotA2(BossX,BossY,0.5,circle+variety,0.02,3,218,10);
			let norm = CreateShotA2(BossX,BossY,0.5,circle+variety,0.02,2,49,10);
			ObjMove_AddPatternA2(reverse,60,1.4,NO_CHANGE,-0.04,0,-3);
			ReflectWalls(norm,ObjMove_GetAngle(norm));
			
		}
	wait(6);
	if(ObjEnemy_GetInfo(BossObj, INFO_LIFE) <= 0){return;}
	}
	wait(180);
	loop(4) {
		loop(numbofbullets) {
			circle+= 360/numbofbullets;
			let reverse = CreateShotA2(BossX,BossY,0.5,circle+variety,0.02,3,218,10);
			let norm = CreateShotA2(BossX,BossY,0.5,circle+variety,0.02,2,49,10);
			ObjMove_AddPatternA2(reverse,60,1.4,NO_CHANGE,-0.04,0,-3);
			ReflectWalls(norm,ObjMove_GetAngle(norm));
			
		}
	wait(6);
	if(ObjEnemy_GetInfo(BossObj, INFO_LIFE) <= 0){return;}
	}
}

task ReflectWalls(obj,ang) {
	while (ObjMove_GetX(obj)>0&&ObjMove_GetX(obj)<GetStgFrameWidth) {yield;}
	if (ObjMove_GetX(obj)<=0) {
			ObjMove_SetX(obj,0);
			ObjMove_SetAngle(obj,180-ang);
		}
	if (ObjMove_GetX(obj)>=GetStgFrameWidth) {
			ObjMove_SetX(obj,GetStgFrameWidth);
			ObjMove_SetAngle(obj,180-ang);
		}
}

//Square Fire Task From Arby26
task TSquare(obj, base_ang, size){
        let numPoints = 14; //changed -Achy
        let ex = ObjMove_GetX(obj);
        let ey = ObjMove_GetY(obj);
 
        let dist = (size/2);
        dist = (2*(dist^2))^0.5;
 
        let cx = 0.0;
        let cy = 0.0;
        let c_ang = 0.0;
 
        let shotAng = base_ang;
        let shotAngD = 360/(4*numPoints);
 
        ascent(c in 0..2){ //changed -Achy
                // Get position of the corner of the square
                let n_base_ang = base_ang +c*180; //changed, makes it two walls -Achy
                cx = ObjMove_GetX(obj) +cos(n_base_ang)*dist;
                cy = ObjMove_GetY(obj) +sin(n_base_ang)*dist;
                c_ang = n_base_ang +135;
                let cosine = cos(c_ang);
                let sine = sin(c_ang);
 
                ascent(i in 0..numPoints){
                        // Using the corner position, get a position down the edge of the square
                        let x = cx +cosine*i*size/numPoints;
                        let y = cy +sine*i*size/numPoints;
						if(ObjEnemy_GetInfo(BossObj, INFO_LIFE) <= 0){return;}
                       
					   CreateShotA2(x,y, -0.5, n_base_ang+225, 0.02, rand(0.5,2), 151, 30);
 
                        shotAng+=shotAngD;
						wait(1);
                }
			
        }
}


task EndScript{
	while(ObjEnemy_GetInfo(BossObj, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(BossObj);
	loop(60) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	CloseScript(GetOwnScriptID());
}