#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["Karen Spell #2"]
#text["Karen's 2nd Spellcard"]

let bossObj;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "IMG/Karen.png";
let Deepsea = GetCurrentScriptDirectory ~ "IMG/Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "IMG/Deepnessseaweed.png";
let SpellFog = GetCurrentScriptDirectory ~ "IMG/SpellFog.png";
let line;
let line2;
let line3;
let fandir;
let framage = 0;
let fra2 = 0;
let lel;
let Halfring = 90;

#include "./Custshot/AchyShot_Const.cs"

@Initialize {

	bossObj = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(bossObj);
	
	ObjPrim_SetTexture(bossObj,imgBoss);
	ObjSprite2D_SetSourceRect(bossObj,0,0,110,145);
	ObjSprite2D_SetDestCenter(bossObj);
	ObjEnemy_SetDamageRate(bossObj,0,0);
	ObjMove_SetDestAtSpeed(bossObj,192,120,5);
	
	Ending;
	
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(4500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(bossObj);
	BossY = ObjMove_GetY(bossObj);
	
	ObjEnemy_SetIntersectionCircleToShot(bossObj,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(bossObj,BossX,BossY,32);
	
	
	
	yield;
	
}

@Finalize {

}

function wait(w) { loop(w) { yield; } }

task mainTask {

	RenderBG;
	wait(200);
	loop {
		Sonar;
		wait(270);
		ObjMove_SetDestAtWeight(bossObj,rand(142,242),rand(80,160),20,4);
		wait(60);
	}
	
}

task RenderBG {
	//Spellfog & scroll
	let BGobj3 = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(BGobj3,24);
	ObjPrim_SetTexture(BGobj3,SpellFog);
	ObjSprite2D_SetDestRect(BGobj3,0,0,GetStgFrameWidth,GetStgFrameHeight);
	ObjRender_SetAlpha(BGobj3,20);
	let count = 1800;
	wait(1);
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0) {
		ObjSprite2D_SetSourceRect(BGobj3,0,count-900,900,count);
		count--;
		if (count == 900) {count = 1800}
		yield;
	}
	Obj_Delete(BGobj3);
	
}

function angleToPlayer {
	let dir = atan2(GetPlayerY-BossY,GetPlayerX-BossX);
	return dir;
	
}

task Sonar {
	ObjEnemy_SetDamageRate(bossObj,80,50);
	let Angless = rand(0,360);
	let Hlfrngdir = rand(-10,10);
	ascent (i in 0..90) {
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		Angless+=45;
		lel = CreateShotA1(BossX,BossY,2,Angless,12,0);
		Angless+=360/45;
		ObjMove_AddPatternA3 (lel,90-i,-0.5,Angless+11.25,0.01,0,0.5,18);
	}
	wait(60);
	if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	descent (i in 0..180) {
		Angless-=90;
		lel = CreateShotA1(BossX,BossY,2,Angless,12,0);
		Angless-=360/90;
		ObjMove_AddPatternA3 (lel,0+i*0.90,-0.5,Angless+180,0.01,0,2,19);
		}
	wait(90);
	if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	ascent (i in 0..90) {
		if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
		Halfring+=2;
		CreateShotA2(BossX,BossY-45,0,Halfring+Hlfrngdir,0.01,1.7,225,5);
	}
	ascent (i in 0..30) {
	if(ObjEnemy_GetInfo(bossObj, INFO_LIFE) <= 0){return;}
	Halfring+=360/30;
	CreateShotA2(BossX,BossY-45,0,Halfring+Hlfrngdir,0.01,1.7,225,5);
	
	}
}
	
task Ending {
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(bossObj);
	loop(60) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	CloseScript(GetOwnScriptID());
}