#TouhouDanmakufu[single]
#ScriptVersion[3]
#Title["TestSwarm"]
#text["Trying to replicate an idea"]

let bossObj;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "IMG/Karen.png";
let Deepsea = GetCurrentScriptDirectory ~ "IMG/Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "IMG/Deepnessseaweed.png";
let SpellFog = GetCurrentScriptDirectory ~ "IMG/SpellFog.png";
let count = 0;
let angle;
let Buzzshot;
let ZAPshot;

#include "./Custshot/AchyShot_Const.cs"

@Initialize {

	bossObj = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(bossObj);
	
	ObjPrim_SetTexture(bossObj,imgBoss);
	ObjSprite2D_SetSourceRect(bossObj,0,0,110,145);
	ObjSprite2D_SetDestCenter(bossObj); 
	
	ObjMove_SetDestAtSpeed(bossObj,192,120,5);
	
	TEnd;
	
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(1700);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(bossObj);
	BossY = ObjMove_GetY(bossObj);
	
	ObjEnemy_SetIntersectionCircleToShot(bossObj,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(bossObj,BossX,BossY,32);
	
	
	
	yield;
	
}

@Finalize {

}

function wait(w) { loop(w) { yield; } }

task mainTask {
	RenderBG;
	ObjEnemy_SetDamageRate(bossObj,0,0);
	wait(200);
	Uglow;
	Buzzbuzz;
	obstacle;
	wait(100);
	ObjMove_SetDestAtSpeed(bossObj,192,200,2);
}

task RenderBG {
	//Spellfog & scroll
	let BGobj3 = ObjPrim_Create(OBJ_SPRITE_2D);
	Obj_SetRenderPriorityI(BGobj3,24);
	ObjPrim_SetTexture(BGobj3,SpellFog);
	ObjSprite2D_SetDestRect(BGobj3,0,0,GetStgFrameWidth,GetStgFrameHeight);
	ObjRender_SetAlpha(BGobj3,20);
	let count = 1800;
	wait(1);
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0) {
		ObjSprite2D_SetSourceRect(BGobj3,0,count-900,900,count);
		count--;
		if (count == 900) {count = 1800}
		yield;
	}
	Obj_Delete(BGobj3);
	
}

task Buzzbuzz {

	loop(60){
		count+=360/80*4;
		Buzzshot = CreateShotA2 (BossX,BossY-45,1,count,-0.01,0,75,10);
		ObjShot_SetSpellResist(Buzzshot,true);
		MoveBuzz(Buzzshot);
		wait(1);
	}
}

task Uglow {
	let UGLOW = CreateShotA1(5,5,0,0,235,0);
	ObjShot_SetSpellResist(UGLOW,true);
	ObjShot_SetIntersectionEnable(UGLOW,false);
	Obj_SetRenderPriority(UGLOW,0.25);
	ObjRender_SetScaleX(UGLOW,2);
	ObjRender_SetScaleY(UGLOW,2);
	loop(1400) {
		ObjMove_SetPosition(UGLOW,GetPlayerX,GetPlayerY);
		wait(1);
	}
	ObjShot_FadeDelete(UGLOW);
}

task MoveBuzz(obj) {
	wait(80);
	ObjShot_SetSpellResist(obj,true);
	loop(20) {
		ObjMove_SetDestAtWeight(obj,GetPlayerX+rand(-60,60),GetPlayerY+rand(-60,60),50,40);
		wait(rand(30,100));
		}
	ObjMove_AddPatternA3(obj,40,NO_CHANGE,NO_CHANGE,0.02,0,1,67);
	ReflectBorderMirans(obj);
	wait(1200);
	ObjMove_AddPatternA3(obj,10,NO_CHANGE,NO_CHANGE,-0.02,0,0,77);
}

task obstacle{
	wait(200);
	let count = 0;
	loop(5){
		loop(3){
			let bultcol = 50;
			count+=360/12;
			ascent(i in 0..20) {
				count+=360/3;
				if (i == 10) { bultcol = 219; }
				CreateShotA1(BossX,BossY,0.7+i*0.02,count+i/0.125,bultcol,10);
			}
		wait(90);
		}
	}
	wait(90);
	loop(5){
		loop(3){
			let bultcol = 51;
			count-=360/17;
			ascent(i in 0..20) {
				count-=360/3;
				if (i == 10) { bultcol = 220; }
				CreateShotA1(BossX,BossY,0.7+i*0.03,count+i/0.125,bultcol,10);
			}
		wait(60);
		}
	}
	wait(90);
			let bultcol = 52;
			loop(180){
			count-=2;
				loop(3){
					count+=360/3;
					CreateShotA1(BossX,BossY,1,count,221,20);
				}
			wait(2);	
	}
	wait(90);
	loop(180){
		count-=360/180;
		CreateShotA1(BossX,BossY,0.7,count,230,20);
		CreateShotA1(BossX,BossY,0.4,count,230,20);
		CreateShotA1(BossX,BossY,0.1,count,230,20);
	}
}



task ReflectBorderMirans(obj) {
        while (!Obj_IsDeleted(obj)) {
                if (ObjMove_GetX(obj)<0) {
                        ObjMove_SetX(obj,-ObjMove_GetX(obj));
                        ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
                }
                else if (ObjMove_GetX(obj)>GetStgFrameWidth) {
                        ObjMove_SetX(obj,GetStgFrameWidth*2-ObjMove_GetX(obj));
                        ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
                }
                else if (ObjMove_GetY(obj)<0) {
                        ObjMove_SetY(obj,0-ObjMove_GetY(obj));
                        ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
                }
                else if (ObjMove_GetY(obj)>GetStgFrameHeight) {
                        ObjMove_SetY(obj,GetStgFrameHeight*2-ObjMove_GetY(obj));
                        ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
                }
                yield;
        }
}

task deletetime(obj,time) {

	wait(time);
	ObjShot_FadeDelete(obj);

}

task TEnd{
	while(ObjEnemy_GetInfo(bossObj, INFO_LIFE) > 0)
	{
		yield;
	}
	Obj_Delete(bossObj);
	loop(60) {
		DeleteShotAll(TYPE_ALL, TYPE_ITEM);
		yield;
	}
	CloseScript(GetOwnScriptID());
}